#include <stdio.h> 
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#include <time.h>
#include "stack.h"

jmp_buf	env;

void main() {

	int 			i, ret_val; 
	unsigned int	oldsp, newsp, chksp;
	
	ret_val = 293;
	printf("** size of jmp_buf: %d ****\n", sizeof(jmp_buf));
	if ((ret_val =  setjmp( env )) == 0 ) 
	{ 
		printf("after setjmp %d\n", ret_val);
		prn();
		pthread_get_sp(&oldsp);
		newsp = oldsp - 0x400;
		pthread_set_sp(newsp);
		pthread_get_sp(&chksp);
		printf("oldsp = %xH\n", oldsp);
		printf("newsp = %xH\n", newsp);
		printf("chksp = %xH\n", chksp);
		pthread_set_sp(oldsp);
		rtn();
	} 
	else 
	{
		printf(" back from long jump %d\n", ret_val);
		return;
	}
}

prn(){

	int i;

	printf("\tContents of jump buffer\n");
	for( i=0; i<13; ++i) 
		printf("%s:\tbuf[%d] = %xH\n", reg_names[i], i, env[i]);
}
rtn() {
	printf( "about to longjmp\n" );
	longjmp( env, 14);	
}