#include <stdio.h> 
#include <stdlib.h>
#include <string.h>
#include <setjmp.h>
#include <time.h>
#include "stack.h"

jmp_buf	env1;
jmp_buf	env2;

void main() 
{
	func1();	
	printf("func1 return correctly\n");
	return;
}

void func1() 
{
	int 			i, ret_val; 
	unsigned int	oldsp, newsp, chksp;
	
	ret_val = 293;
	printf("** size of jmp_buf: %d ****\n", sizeof(jmp_buf));
	if ((ret_val =  setjmp(env1)) == 0 ) 
	{ 
		printf("after setjmp %d\n", ret_val);
		prn1();
		pthread_get_sp(&oldsp);
		newsp = oldsp - 0x400;
		pthread_set_sp(newsp);
		pthread_get_sp(&chksp);
		if ((ret_val =  setjmp(env2)) == 0 ) 
		{ 
			printf("after setjmp %d\n", ret_val);
			printf("oldsp = %xH\n", oldsp);
			printf("newsp = %xH\n", newsp);
			printf("chksp = %xH\n", chksp);
			prn2();
			longjmp(env1, 10);	
		}
		else
		{
			pthread_set_sp(oldsp);
			prn2();
			printf("back from long jump %d\n", ret_val);
			return;
		}
	} 
	else 
	{
		printf(" back from long jump %d\n", ret_val);
		prn1();
		longjmp(env2, 20);	
	}
}

prn1(){

	int i;

	printf("\tContents of jump buffer\n");
	for( i=0; i<13; ++i) 
		printf("%s:\tbuf[%d] = %8xH\n", reg_names[i], i, env1[i]);
}

prn2(){

	int i;

	printf("\tContents of jump buffer\n");
	for( i=0; i<13; ++i) 
		printf("%s:\tbuf[%d] = %8xH\n", reg_names[i], i, env2[i]);
}

rtn() {
	printf( "about to longjmp\n" );
	longjmp( env1, 14);	
}