#include <stdio.h> 
#include <setjmp.h>

#pragma aux sym frame;
jmp_buf	env;

void main() {

	int 	i, ret_val; 
	
	ret_val = 293;
	i = 12;
	printf("** size of jmp_buf: %d ****\n", sizeof(jmp_buf));
	if( (ret_val =  setjmp( env )) == 0 ) 
	{ 
		printf("after setjmp %d\n", ret_val);
		prn();
		sub1(i);
		printf("back from sub.\n", ret_val);
		return;
	} 
	else 
	{
		printf(" back from long jump %d\n", ret_val);
		return;
	}
}

void sub1(int i) 
{

	int 	ret_val; 
	
	ret_val = 293;
	if( (ret_val =  setjmp( env )) == 0 ) 
	{ 
		printf("after setjmp %d inside sub\n", ret_val);
		prn();
		rtn();
	} 
	else 
	{
		printf(" back from long jump %d\n", ret_val);
		return;
	}
}

prn(){

	int i;

	printf("\tContents of jump buffer\n");
	for( i=0; i<13; ++i) 
		printf("buf[%d] = %xH\n", i, env[i]);
}

rtn() {
	printf( "about to longjmp\n" );
	longjmp( env, 14);	
}